
//  HiirenKuunteluApplet.java  (c) 2005 Kari Laitinen

//  http://www.naturalprogramming.com

//  2005-10-20  Tiedosto luotu.
//  2006-10-18  Viimeisin muutos.

import java.awt.* ;
import java.awt.event.* ;
import java.util.ArrayList ;

public class HiirenKuunteluApplet extends javax.swing.JApplet
                                  implements MouseListener,
                                             MouseMotionListener
{
   ArrayList<String>  naytettavat_tekstirivit  =  new  ArrayList<String>() ;

   public void init()
   {
      getContentPane().setBackground( Color.cyan ) ; // cyan taustavariksi

      addMouseListener(this);
      addMouseMotionListener(this);

      naytettavat_tekstirivit.add( "Talla apletilla voidaan tutkia hiiren" ) ;
      naytettavat_tekstirivit.add( "painamisesta ja liikuttelusta seuraavia" );
      naytettavat_tekstirivit.add( "tapahtumia. Klikkaile ja liikuta hiirta" );
      naytettavat_tekstirivit.add( "apletin alueella ja sen ulkopuolella" ) ;
      naytettavat_tekstirivit.add( "" ) ;
      naytettavat_tekstirivit.add( "" ) ;
   }

   public void mouseEntered( MouseEvent tapahtuma )
   {
      naytettavat_tekstirivit.add( "mouseEntered()-metodia kutsuttu." ) ;

      repaint() ;
   }

   public void mouseExited( MouseEvent tapahtuma )
   {
      naytettavat_tekstirivit.add( "mouseExited()-metodia kutsuttu." ) ;

      repaint() ;
   }

   public void mousePressed( MouseEvent tapahtuma )
   {
      Point   klikkauskohta  =  tapahtuma.getPoint() ;

      naytettavat_tekstirivit.add( "mousePressed()  Point ("
                        +  klikkauskohta.x  +  ", "  +  klikkauskohta.y 
                        +  "). isAltDown() SANOO: "
                        +  tapahtuma.isAltDown() ) ;
      repaint() ;
   }

   public void mouseReleased( MouseEvent tapahtuma )
   {
      if ( tapahtuma.isShiftDown() )
      {
         naytettavat_tekstirivit.add( "mouseReleased()  SHIFT alhaalla." ) ;
      }
      else
      {
         naytettavat_tekstirivit.add( "mouseReleased()  SHIFT ei alhaalla." ) ;
      }

      repaint() ;
   }

   public void mouseClicked( MouseEvent tapahtuma )
   {
      if (  tapahtuma.getButton() ==  MouseEvent.BUTTON1 )
      {
         naytettavat_tekstirivit.add( "mouseClicked() VASEN HIIREN NAPPI" ) ;
      }
      else
      {
         naytettavat_tekstirivit.add( "mouseClicked() EI VASEN HIIREN NAPPI" );
      }

      repaint() ;
   }

   public void mouseMoved( MouseEvent tapahtuma )
   {
      naytettavat_tekstirivit.add( "mouseMoved()" ) ;

      repaint() ;
   }

   public void mouseDragged( MouseEvent tapahtuma )
   {
      naytettavat_tekstirivit.add( "mouseDragged()" ) ;

      repaint() ;
   }

   public void paint( Graphics graphics )
   {
      super.paint( graphics ) ;

      //  Tuhotaan ArrayList-taulukosta ensimmainen tekstirivi kunnes
      //  riveja on siella korkeintaan 24 kappaletta.

      while ( naytettavat_tekstirivit.size() > 24 )
      {
         naytettavat_tekstirivit.remove( 0 ) ;
      }

      for ( int rivin_indeksi  =  0 ;
                rivin_indeksi  <  naytettavat_tekstirivit.size() ;
                rivin_indeksi  ++ )
      {
         graphics.drawString( naytettavat_tekstirivit.get( rivin_indeksi ),
                              30,
                              20 + rivin_indeksi * 20 ) ;
      }
   }
}



